<?xml version="1.0" encoding="utf-8"?>
<s:TitleWindow  xmlns:fx="http://ns.adobe.com/mxml/2009"
			   xmlns:s="library://ns.adobe.com/flex/spark"
			   xmlns:ui="library://ns.adobe.com/flex/ui"
			   xmlns:mx="library://ns.adobe.com/flex/mx"
			   xmlns:components="br.com.dclick.components.*"
			   xmlns:componente="br.com.desenv.framework.componente.*"
			   close="titlewindowCloseHandler(event)"  creationComplete="creationCompleteHandler(event)" title="Cadastro de Atividade" xmlns:visual="br.com.desenv.framework.component.visual.*">
	
	<fx:Style source="../../../framework/util/estilo.css"/>

	
	<fx:Metadata>
		[Event(name="AtividadeIncluidoEvent")]
		[Event(name="AtividadeAtualizadoEvent")]
		[Event(name="AtividadeExcluidoEvent")]
		[Event(name="AtividadeSelecionadoEvent")]
		
	</fx:Metadata>

	<fx:Script>
		<![CDATA[
			import br.net.upcode.framework.amf.AMFConnector;
			import br.net.upcode.framework.popup.UPCPopUpManager;
			import br.com.desenv.framework.util.DsvObjectUtil;
			import mx.core.FlexGlobals;;
			import mx.collections.ArrayCollection;
			import mx.rpc.events.FaultEvent;
			import mx.rpc.events.ResultEvent;
			import mx.rpc.remoting.mxml.RemoteObject;
			import mx.controls.Alert;
			
			import mx.controls.DateField;
			import mx.events.CloseEvent;
			import mx.events.FlexEvent;
			import mx.managers.PopUpManager;
			
			
			import mx.validators.Validator;
			
			import br.com.desenv.nepalign.vo.Atividade;
			
			// Alguem passa a objeto para ca
			public var atividade : Atividade = new Atividade();
			

			
			[Bindable]
			private var listaValidadorForm: Array = new Array();
			
// ---------------------------------- FUNCOES DE INICIALIZACAO E FINALIZACAO --------------------------------			
			private function validar(event: MouseEvent):Boolean 
			{
				var listaErroValidador:Array = Validator.validateAll(this.listaValidadorForm);
				var validado:Boolean = listaErroValidador.length == 0;
				return validado;
			}
			
			// Indica todas as validacoes necessarias
			private function carregarListaValidacao(): void
			{
				//implemente aqui outros validadores se necessario
			}
			
			private function limparListaCampo(): void
			{
				ignTextInputDescricao.text = "";
				ignTextInputCnae.text = "";
			}
			
			// Chama ao completar o carregamento da pagina
			private function creationCompleteHandler( event: FlexEvent ): void 
			{
				carregarListaValidacao();
				
				
				// Se e um novo cadastro
				if (this.atividade.id == 0)
				{
					limparListaCampo();
				}
				// Se alguem passou o objeto
				else
				{
					ignTextInputDescricao.text = this.atividade.descricao;

					ignTextInputCnae.text = this.atividade.cnae;

				}
			}
			
			
			
			
			// Chama quando fecha a janela no X
			protected function titlewindowCloseHandler(event:CloseEvent):void
			{
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- SALVAR E ATUALIZAR  --------------------------------	
			private function buttonSalvar_clickHandler( event: MouseEvent ): void 
			{
				if (validar(event))
				{
					// Se e alteracao
					if (atividade.id != 0) 
					{
						atividade.descricao = ignTextInputDescricao.text;
						atividade.cnae = ignTextInputCnae.text;
						var remoteObjectAtualizar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("atividadeService", atualizarResultHandler);	
						remoteObjectAtualizar.getOperation("atualizar").send(atividade); 
					// Se e inclusao
					} 
					else 
					{
						atividade.descricao = ignTextInputDescricao.text;

						atividade.cnae = ignTextInputCnae.text;

						var remoteObjectSalvar: RemoteObject  = AMFConnector.instance.prepararObjetoRemoto("atividadeService", salvarResultHandler);	
						remoteObjectSalvar.getOperation("salvar").send(atividade); 
					}
				}	
			}

			
			// Depois que salva fecha a janela
			private function salvarResultHandler( event: ResultEvent ): void 
			{
				this.atividade = event.result as Atividade;
				this.dispatchEvent(new ResultEvent("AtividadeIncluidoEvent",false, true, this.atividade, null, null));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
			// Depois que atualiza fecha a janela
			private function atualizarResultHandler( event: ResultEvent ): void 
			{
				this.atividade = event.result as Atividade;
				this.dispatchEvent(new Event("AtividadeAtualizadoEvent"));
				UPCPopUpManager.instance.removePopUp(this);
			}
			
// ---------------------------------- LIMPAR  --------------------------------	
			protected function buttonLimpar_clickHandler(event:MouseEvent):void
			{
				limparListaCampo();
			}
						
// ---------------------------------- ADICIONAR DINAMICAMENTE  --------------------------------				

			
// ---------------------------------- PESQUISAR AUTOR ABRINDO A LISTA  --------------------------------				
		]]>
	</fx:Script>
	
	<fx:Declarations>
		<!-- Place non-visual elements (e.g., services, value objects) here -->
		<!-- <mx:Validator id="validatorObrigatorioSituacaoAtividade" property="selectedItem" required="true" source="{comboBoxSituacaoAtividade}" trigger="{comboBoxSituacaoAtividade}" triggerEvent="valueCommit"/> -->
		
	</fx:Declarations>
	

	<mx:Grid styleName="grid" verticalScrollPolicy="auto" horizontalScrollPolicy="auto" maxHeight="600" maxWidth="1024">
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>	
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="Atividade:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoDescricao" styleName="labelValidacao" text="{ignTextInputDescricao.errorString}"/>
					<visual:IgnTextInput id="ignTextInputDescricao" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}" width="300"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem styleName="gridLabel">
				<s:Label text="CNAE:"/>
			</mx:GridItem>
			<mx:GridItem styleName="gridValor">
				<s:VGroup>
					<s:Label id="labelValidacaoCnae" styleName="labelValidacao" text="{ignTextInputCnae.errorString}"/>
					<visual:IgnTextInput id="ignTextInputCnae" maxChars="45" obrigatorio="true" listaValidadorForm="{this.listaValidadorForm}"/>
				</s:VGroup>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Spacer/>
			</mx:GridItem>
		</mx:GridRow>		
		<mx:GridRow>
			<mx:GridItem colSpan="4" horizontalAlign="center">
				<s:Button id="buttonSalvar" label="Salvar" click="buttonSalvar_clickHandler(event)"/>
				<s:Button id="buttonLimpar" label="Limpar" click="buttonLimpar_clickHandler(event)"/>
			</mx:GridItem>
		</mx:GridRow>
	</mx:Grid>
</s:TitleWindow>